HDU 1051-Wooden Sticks (贪心)

题目:https://vjudge.net/problem/HDU-1051
There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows:  

(a) The setup time for the first wooden stick is 1 minute.  
(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l' and weight w' if l<=l' and w<=w'. Otherwise, it will need 1 minute for setup.  

You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).  
InputThe input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case, and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.  
OutputThe output should contain the minimum setup time in minutes, one per line.  
Sample Input
3 
5 
4 9 5 2 2 1 3 5 1 4 
3 
2 2 1 1 2 2 
3 
1 3 2 2 3 1
Sample Output
2
1
3

题目大意:有n个木棍,木棍有各自的长度和重量,机器每处理一个木棍需要准备1分钟,但是会如果处理的接下来的木棍的长度和重量都不大于上一个的话,就不需要准备,求最后需要花费的最少时间。
解题思路:贪心,先对木棍的长度或者宽度进行排序,我是从小到大排序的,然后再从头遍历,用二层循环来找出需要花费的时间,其中第二层是对重量进行的判断,因为长度已经是排好序的,所以只需要往后找就可以。

AC代码:

#include<iostream>
#include<algorithm>
#include<string>
using namespace std;
const int maxn = 5000 + 10;
int n;
int T;
bool f[maxn];
struct Node
{
	int l;
	int w;
}a[maxn];
bool cmp(Node a,Node b)
{
	if (a.l != b.l)
		return a.l < b.l;
	else
		return a.w < b.w;
}
int main()
{
	cin >> T;
	while (T--)
	{
		cin >> n;
		for (int i = 0; i < n; i++)
		{
			cin >> a[i].l >> a[i].w;
		}
		memset(f, false, sizeof(f));
		sort(a, a + n,cmp);
		int cnt = 0;
		for (int i = 0; i < n; i++)
		{
			if (f[i]) continue;
			int mi = a[i].w;
			f[i] = true;
			for (int j = i + 1; j < n; j++)
			{
				if (f[j]) continue;
				if (a[j].w >= mi && !f[j])
				{
					mi = a[j].w;
					f[j] = true;
				}
			}
			cnt++;
		}
		cout << cnt << endl;
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_40129237/article/details/80269228